var datosCargados = new Boolean(false);
var catCargadas = new Boolean(false);

function onDeviceReady() {
    StatusBar.overlaysWebView(false);
}

document.addEventListener('deviceready', onDeviceReady, false);

window.misCongeladoresView = Backbone.View.extend({
  
    template:_.template($('#misCongeladores').html()),

    events:{
        'click #verProductosBtn':'verProductos'
    },

    render:function (eventName) {
       if (datosCargados == false){
            var query = new Parse.Query(CongeladorModel);
            query.ascending("nombreCongelador");

            query.find({
                success: $.proxy(function(result){
                    //result is an array of parse.object
                    localStorage.setItem("congeladores", JSON.stringify(result));

                    datosCargados=true;
                    window.setTimeout(app.changePage(new misCongeladoresView()),100);                   

                    return this;
                },this),

                error: function(error){
                    //instance of parse.error
                }
            });

            this.query = query;
        }else{
            var congArray = JSON.parse(localStorage.getItem("congeladores"));
            $(this.el).html(this.template({congeladores: congArray}));
        }

        if(catCargadas==false){
            var query2 = new Parse.Query(CategoriaModel);
            query2.ascending("idCategoria");
                query2.find({
                success:$.proxy(function(categorias){
                    //categorias is an array of parse.object
                    localStorage.setItem("categorias", JSON.stringify(categorias));

                    catCargadas=true;

                return this;
                },this),
                error: function(error){
                    //instance of parse.error
                }
            });
            this.query2 = query2;
        }

        datosCargados=false;
        return this;
    },

    verProductos:function(){
        var congeladoresSeleccionados =new Array();
        $('input[name="ckVerProductos[]"]:checked').each(function(){
               var congeladorChecked = $(this).val();
                congeladoresSeleccionados.push(congeladorChecked);
        });

        var congeladoresStore = JSON.parse(localStorage.congeladores);
        var storeCollection = new CongeladorCollection(congeladoresStore);

        var congSelObject = new Array();
        for(var i=0; i<congeladoresSeleccionados.length; i++){ 
           
            var primerCong = congeladoresSeleccionados[i];
            var primerCongStore = storeCollection.get(primerCong);
            congSelObject.push(primerCongStore);
        } 

        localStorage.setItem("congeladoresChecked", JSON.stringify(congSelObject));
    }

});

window.nuevoCongeladorView = Backbone.View.extend({

    template:_.template($('#nuevoCongelador').html()),

    events:{
        'click #guardarBtn':'submit'
    },

    render:function (eventName) {
        //Com hem de crear un nou congelador, no hem de mostrar cap valor
        this.collection=new CongeladorCollection();

        $(this.el).html(this.template({congeladores: this.collection.toJSON()}));
        return this;
    },

    submit: function(e){
        event.preventDefault();
            var valores = {};

            valores.nombreCongelador = $('#nombreCongelador').val();
            valores.descripcionCongelador = $('#txtAreaDescripcion').val();
            valores.colorCongelador = $('#colorCongelador').val();
            valores.iconoCongelador = $("input[name=radio-choice-h-2]:checked").val();


            if($('#nombreCongelador').val().length < 1 ){
                alert("El nombre del congelador es obligatorio");
                return false;
            }else{
                valores.nombreCongelador = $('#nombreCongelador').val();
            };

            console.log("Valores: ", valores);

             //guardam els valors a Parse. 
             //A localStorage no fa falta perque els carrega en fer la query a misCongeladores
             this.guardaParse(valores);
    },

    guardaParse: function(ob){
        var guardarCongelador = new CongeladorModel();
        guardarCongelador.save(ob,{
            success: function(object){
                console.log("Guardado en parse.");
                console.dir(object);
                $('#formAlta').submit();
            },
            error: function(model, error){
                console.log("Error! ");
                console.dir(error);
            }
        });
    }
});

window.editarCongeladorView = Backbone.View.extend({

    template:_.template($('#nuevoCongelador').html()),

    events:{
        'click #guardarBtn':'submit'
    },

    //Agafam el valor de la url que ens interessa
    urlParam: function (name) {
    var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (results != null)
     return results[1] || 0;
    else
     return results;
    //return results != null ? results[1] || 0 : results;
    },

    
    render:function (eventName) {
        var idEditar = this.urlParam('id');
        //console.log("parametro url: "+this.urlParam('id'));

        //Cream una coleccio amb els congeladors guardats a localStorage
        var congeladoresStore = JSON.parse(localStorage.congeladores);
        var storeCollection = new CongeladorCollection(congeladoresStore);

        //Agafam el congelador que es vol editar (amb id igual al de la url).
        var congeladorEditar = storeCollection.get(idEditar);

        //cream una coleccio amb aquest objecte
        var listaCongeladores = new CongeladorCollection([congeladorEditar]);
        this.collection=listaCongeladores;

        $(this.el).html(this.template({congeladores: this.collection.toJSON()}));

        return this;
    },

    submit: function(e){
            event.preventDefault();
            var valores = {};

            valores.nombreCongelador = $('#nombreCongelador').val();
            valores.descripcionCongelador = $('#txtAreaDescripcion').val();
            valores.colorCongelador = $('#colorCongelador').val();
            valores.iconoCongelador = $("input[name=radio-choice-h-2]:checked").val();

            if($('#nombreCongelador').val().length < 1 ){
                alert("El nombre del congelador es obligatorio");
                return false;
            }else{
                valores.nombreCongelador = $('#nombreCongelador').val();
            };

            console.log("Valores: ", valores);

             //Actualitzam els valors a Parse. 
             //A localStorage no fa falta perque els carrega en fer la query a misCongeladores
             this.actualizaParse(valores);
    },

    actualizaParse: function(valores){
        var idEditar = this.urlParam('id');

        var editado = Parse.Object.extend("Congelador");
        var query = new Parse.Query(editado);
        query.equalTo("objectId", idEditar);

        query.first({
            success: function(object){
                object.set("nombreCongelador", valores.nombreCongelador);
                object.set("descripcionCongelador", valores.descripcionCongelador);
                object.set("colorCongelador", valores.colorCongelador);
                object.set("iconoCongelador", valores.iconoCongelador);
                object.save();         

                console.log("Actualizado en parse.");
                console.dir(object);     
                $('#formAlta').submit();
            },
            error: function(error){
                console.log("Error! ");
                console.dir(error);
                 alert("Error: " + error.code + " " + error.message);
            }
        });
    }
});

window.eliminarCongeladorView = Backbone.View.extend({

    template:_.template($('#eliminarCongelador').html()),

    events:{
        'click #confirmarBtn':'eliminaParse'
    },

     //Agafam el valor de la url que ens interessa
    urlParam: function (name) {
    var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (results != null)
     return results[1] || 0;
    else
     return results;
    //return results != null ? results[1] || 0 : results;
    },

    render:function (eventName) {
        var idEliminar = this.urlParam('id');

        //Cream una coleccio amb els congeladors guardats a localStorage
        var congStore = JSON.parse(localStorage.congeladores);
        var storeCollection = new CongeladorCollection(congStore);

        //Agafam el congelador que es vol eliminar (amb id igual al de la url).
        var congEliminar = storeCollection.get(idEliminar);

        //cream una coleccio amb aquest objecte
        var listaCongeladores = new CongeladorCollection([congEliminar]);

        var query = new Parse.Query(ProductoModel);
        query.equalTo("parentCong", {
            __type: "Pointer",
            className: "Congelador",
            objectId: idEliminar
        });       
        query.find({
            success: $.proxy(function(result){
                //localStorage.setItem("congProdEliminar", JSON.stringify(result));
                $(this.el).html(this.template({congeladores:listaCongeladores.toJSON(), productos:result}));
              },this),
            error: function(error){
                console.log("Error! ");
                console.dir(error);
            }
        });

        return this;
    },

    eliminaParse: function(){
        event.preventDefault();
        var idEliminar = this.urlParam('id');
 
        var query = new Parse.Query(ProductoModel);
        query.equalTo("parentCong", {
            __type: "Pointer",
            className: "Congelador",
            objectId: idEliminar
        });       
        query.find({
            success: $.proxy(function(result){
                //eliminamos los productos del congelador
                Parse.Object.destroyAll(result, {
                    success: function(){
                       var eliminado = Parse.Object.extend("Congelador");
                        var query = new Parse.Query(eliminado);
                        query.get(idEliminar, {
                            success: function(object){
                                //eliminamos el congelador
                                object.destroy({});         
                                console.log("Eliminado en parse.");  
                                window.location = $('#confirmarBtn').attr('href'); 
                            },
                            error: function(error){
                                console.log("Error! ");
                                console.dir(error);
                            }
                        });
                    },
                    error: function(error){
                        console.log("Error! ");
                        console.dir(error);
                    }
                });        
            },this),
            error: function(error){
                console.log("Error! ");
                console.dir(error);
            }
        }); 
    }
});

window.enviarCongeladorView = Backbone.View.extend({

    template:_.template($('#enviarCongelador').html()),

    events:{
        'click #confirmarBtn':'enviarMail'
    },

    //Agafam el valor de la url que ens interessa
    urlParam: function (name) {
    var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (results != null)
     return results[1] || 0;
    else
     return results;
    //return results != null ? results[1] || 0 : results;
    },

    
    render:function (eventName) {
        var idEnviar = this.urlParam('id');
        //console.log("parametro url: "+this.urlParam('id'));

        //Cream una coleccio amb els congeladors guardats a localStorage
        var congeladoresStore = JSON.parse(localStorage.congeladores);
        var storeCollection = new CongeladorCollection(congeladoresStore);

        //Agafam el congelador que es vol enviar (amb id igual al de la url).
        var congeladorEnviar = storeCollection.get(idEnviar);

        //cream una coleccio amb aquest objecte
        var listaCongeladores = new CongeladorCollection([congeladorEnviar]);
        this.collection=listaCongeladores;

        $(this.el).html(this.template({congeladores: this.collection.toJSON()}));

        return this;
    },

    enviarMail: function(e){
        var email = $("#emailInput").val();

        var idEnviar = this.urlParam('id');

        //Cream una coleccio amb els congeladors guardats a localStorage
        var congeladoresStore = JSON.parse(localStorage.congeladores);
        var storeCollection = new CongeladorCollection(congeladoresStore);

        //Agafam el congelador que es vol enviar (amb id igual al de la url).
        var congeladorEnviar = storeCollection.get(idEnviar);

        var nombreCongelador =congeladorEnviar.attributes.nombreCongelador;
        var descripcionCongelador = congeladorEnviar.attributes.descripcionCongelador;

        var body2 = "Nombre congelador: "+nombreCongelador+"; Descripcion congelador: "+descripcionCongelador;

        if($('#emailInput').val().length < 1 ){
                alert("El email es obligatorio");
                return false;
        }else{
            if($("#emailInput").val().indexOf('@', 0) == -1 || $("#emailInput").val().indexOf('.', 0) == -1) {  
                alert("La direcci\u00f3n de email es incorrecta");  
                return false;  
            }else{
               var emailAEnviar = "mailto:" +email+
                            "?subject=VFreezer. Envio de Congelador" +
                            "&body="+encodeURIComponent(body2);
               window.open(emailAEnviar);
            }  
        };        
    }

});

window.productosView = Backbone.View.extend({

    template:_.template($('#productos').html()),

       render:function (eventName) {
        if (datosCargados == false){
            var query = new Parse.Query(ProductoModel);
            query.include("parentCong");
            query.include("parentCat");
                query.find({
                success:$.proxy(function(productos){
                    //productos is an array of parse.object
                    localStorage.setItem("productosProd", JSON.stringify(productos));

                    datosCargados=true;
                   window.setTimeout(app.changePage(new productosView()),100);  

                return this;
                },this),
                error: function(error){
                    //instance of parse.error
                }
            });
            this.query = query;
        }else{
            var congProdArray = JSON.parse(localStorage.getItem("congeladoresChecked"));
            var prodProdArray = JSON.parse(localStorage.getItem("productosProd"));
            var catProdArray = JSON.parse(localStorage.getItem("categorias"));
            
            $(this.el).html(this.template({productos:prodProdArray, categorias:catProdArray, congeladores: congProdArray}));
        }
        datosCargados=false;
        return this;
    }
});

window.nuevoProductoView = Backbone.View.extend({

    template:_.template($('#nuevoProducto').html()),

    events:{
        'click #guardarBtn':'submit'
    },

    render:function (eventName) {
        var congArray = JSON.parse(localStorage.getItem("congeladores"));
        var catArray = JSON.parse(localStorage.getItem("categorias"));
        var prodArray = new Array();


        $(this.el).html(this.template({productos:prodArray, categorias:catArray, congeladores: congArray}));
  
        return this;
    },

    submit: function(){
        event.preventDefault();
        var valores = {};

        valores.nombreCongelador = $('#select-congelador').val();
        valores.nombreCategoria = $('#select-categoria').val();
     
        if($('#fecha-congelacion').val().length < 1 || $('#fecha-max-congelacion').val().length < 1 || $('#nombreProducto').val() < 1 ){
            alert("Los campos marcados con * son obligatorios");
            return false;
        }else{
            valores.nombreProducto = $('#nombreProducto').val();

            if ($('#fecha-congelacion').val() >= $('#fecha-max-congelacion').val()){
                alert("La fecha m\u00e1xima de congelaci\u00f3n tiene que ser posterior a la fecha de congelaci\u00f3n");
                return false;
            }else{
                valores.fechaCongelacion = $('#fecha-congelacion').val();
                valores.fechaMaxCongelacion = $('#fecha-max-congelacion').val();
            }
        };

        valores.descripcionProducto = $('#txtAreaDescripcionProd').val();  

        console.log("Valores: ", valores);

        //Guardam els valors a Parse. 
        //A localStorage no fa falta perque els carrega en fer la query a productos
        this.guardaParse(valores);
    },

    guardaParse: function(valores){
        var miProducto = new ProductoModel();

        var catElegida = Parse.Object.extend("Categoria");
        var query2 = new Parse.Query(catElegida);

        var congElegido = Parse.Object.extend("Congelador");
        var query = new Parse.Query(congElegido);
        query.equalTo("nombreCongelador", valores.nombreCongelador);

        query.first({
            success: function(object){
                //object es el cong al q hay que anyadirle el producto
                console.log("congElegido2 ", object);
                
                miProducto.set("nombreProducto",valores.nombreProducto);
                miProducto.set("fechaCongelacion",valores.fechaCongelacion);
                miProducto.set("fechaMaxCongelacion",valores.fechaMaxCongelacion);
                miProducto.set("descripcionProducto",valores.descripcionProducto);

                 //relacionam congelador i producte
                miProducto.set("parentCong", object);

                query2.equalTo("nombreCategoria", valores.nombreCategoria);
                query2.first({
                success: function(objectCat){

                    //relacionam categoria i producte
                    miProducto.set("parentCat", objectCat);

                   //guarda el producte, la categoria i el congelador
                   miProducto.save(null, {
                    success: function(miProducto){
                         $('#formularioAlta').submit();
                        
                    },
                    error: function(miProducto, error){
                        alert("Error: " + error.code + " " + error.message);
                    }
                   });
                },
                error : function(miProducto, error){
                        alert("Error: " + error.code + " " + error.message);
                }
                });       

                console.log("Producto creado en parse.");
                console.dir(object);  
                console.dir(miProducto);   
               
            },
            error: function(error){
                console.log("Error! ");
                console.dir(error);
                alert("Error: " + error.code + " " + error.message);
            }

        });
    }

});

window.editarProductoView = Backbone.View.extend({

    template:_.template($('#nuevoProducto').html()),

    events:{
        'click #guardarBtn':'submit'
    },

    //Agafam el valor de la url que ens interessa
    urlParam: function (name) {
    var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (results != null)
     return results[1] || 0;
    else
     return results;
    //return results != null ? results[1] || 0 : results;
    },

    render:function (eventName) {
        var idEditar = this.urlParam('id');
        //console.log("parametro url: "+this.urlParam('id'));

        //Cream una coleccio amb els productes guardats a localStorage
        var prodStore = JSON.parse(localStorage.productosProd);
        var storeCollection = new ProductoCollection(prodStore);

        //Agafam el producte que es vol editar (amb id igual al de la url).
        var prodEditar = storeCollection.get(idEditar);

        //cream una coleccio amb aquest objecte
        var listaProd = new ProductoCollection([prodEditar]);
        //this.collection=lista;
        var congProdArray = JSON.parse(localStorage.getItem("congeladoresChecked"));
        var catProdArray = JSON.parse(localStorage.getItem("categorias"));
            
        $(this.el).html(this.template({productos:listaProd.toJSON(), categorias:catProdArray, congeladores: congProdArray}));

        return this;
    },

    submit: function(e){
            event.preventDefault();
            var valores = {};

            //Quan s'edita un producte no es pot canviar de congelador ni de categoria.
            //Per fer aixo s'ha d'eliminar el prod i tornar-lo a crear
            valores.nombreProducto = $('#nombreProducto').val();
            valores.descripcionProducto = $('#txtAreaDescripcionProd').val();

            if ($('#fecha-congelacion').val() >= $('#fecha-max-congelacion').val()){
                alert("La fecha m\u00e1xima de congelaci\u00f3n tiene que ser posterior a la fecha de congelaci\u00f3n");
                return false;
            }else{
                valores.fechaCongelacion = $('#fecha-congelacion').val();
                valores.fechaMaxCongelacion = $('#fecha-max-congelacion').val();
            };

            console.log("Valores: ", valores);

             //Actualitzam els valors a Parse. 
             //A localStorage no fa falta perque els carrega en fer la query a productos
             this.actualizaParse(valores);
    },

    actualizaParse: function(valores){
        var idEditar = this.urlParam('id');

        var editado = Parse.Object.extend("Producto");
        var query = new Parse.Query(editado);
        query.equalTo("objectId", idEditar);

        query.first({
            success: function(object){
                object.set("nombreProducto", valores.nombreProducto);
                object.set("fechaCongelacion", valores.fechaCongelacion);
                object.set("fechaMaxCongelacion", valores.fechaMaxCongelacion);
                object.set("descripcionProducto", valores.descripcionProducto);
                object.save();         

                console.log("Actualizado en parse.");
                console.dir(object);     
                $('#formularioAlta').submit();
            },
            error: function(error){
                console.log("Error! ");
                console.dir(error);
                 alert("Error: " + error.code + " " + error.message);
            }
        });
    }
});

window.eliminarProductoView = Backbone.View.extend({

    template:_.template($('#eliminarProducto').html()),

    events:{
        'click #confirmarBtn':'eliminaParse'
    },

     //Agafam el valor de la url que ens interessa
    urlParam: function (name) {
    var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
    if (results != null)
     return results[1] || 0;
    else
     return results;
    //return results != null ? results[1] || 0 : results;
    },

    
    render:function (eventName) {
        var idEliminar = this.urlParam('id');

        //Cream una coleccio amb els productes guardats a localStorage
        var prodStore = JSON.parse(localStorage.productosProd);
        var storeCollection = new ProductoCollection(prodStore);

        //Agafam el producte que es vol eliminar (amb id igual al de la url).
        var prodEliminar = storeCollection.get(idEliminar);

        //cream una coleccio amb aquest objecte
        var listaProd = new ProductoCollection([prodEliminar]);




        $(this.el).html(this.template({productos: listaProd.toJSON()}));

        return this;
    },

    eliminaParse: function(){
        event.preventDefault();
        var idEliminar = this.urlParam('id');

        var eliminado = Parse.Object.extend("Producto");
        var query = new Parse.Query(eliminado);
        query.get(idEliminar, {
            success: function(object){
                object.destroy({});         

                console.log("Eliminado en parse.");   
                window.location = $('#confirmarBtn').attr('href');
            },
            error: function(error){
                console.log("Error! ");
                console.dir(error);
                alert("Error: " + error.code + " " + error.message);
            }
        });
    }
});


var AppRouter = Backbone.Router.extend({

    routes:{
        "":"misCongeladores",
        "nuevoCongelador":"nuevoCongelador",
        "editarCongelador":"editarCongelador",
        "eliminarCongelador":"eliminarCongelador",
        "enviarCongelador":"enviarCongelador",
        "productos":"productos",
        "nuevoProducto":"nuevoProducto",
        "editarProducto":"editarProducto",
        "eliminarProducto":"eliminarProducto"
    },

    initialize:function () {
        // Handle back button throughout the application
        $(".back").live('click', function(event) {
            window.history.back();
            return false;
        });
        this.firstPage = true;
    },

    misCongeladores:function () {
        console.log('#misCongeladores');
        this.changePage(new misCongeladoresView());
    },

    nuevoCongelador:function () {
        console.log('#nuevoCongelador');
        this.changePage(new nuevoCongeladorView());
    },

    editarCongelador:function () {
        console.log('#editarCongelador');
        this.changePage(new editarCongeladorView());
    },

    eliminarCongelador:function () {
        console.log('#eliminarCongelador');
        this.changePage(new eliminarCongeladorView());
    },

    enviarCongelador:function () {
        console.log('#enviarCongelador');
        this.changePage(new enviarCongeladorView());
    },

    productos:function () {
        console.log('#productos');
        this.changePage(new productosView());
    },

    nuevoProducto:function () {
        console.log('#nuevoProducto');
        this.changePage(new nuevoProductoView());
    },

    editarProducto:function () {
        console.log('#editarProducto');
        this.changePage(new editarProductoView());
    },

    eliminarProducto:function () {
        console.log('#eliminarProducto');
        this.changePage(new eliminarProductoView());
    },

    changePage:function (page) {
        $(page.el).attr('data-role', 'page');
        page.render();
        $('body').append($(page.el));
       // var transition = $.mobile.defaultPageTransition;
       var transition = 'none';
        // We don't want to slide the first page
       /*
        if (this.firstPage) {
            transition = 'none';
            this.firstPage = false;
        }
        */
        $.mobile.changePage($(page.el), {changeHash:false, transition: transition});
    }

});

var CongeladorModel = Parse.Object.extend({
    className: "Congelador",

    initialize:function(){
        console.log("Modelo de congeladores");
    },
  
  defaults : {
    nombreCongelador: 'No especificado',
    descripcionCongelador: 'Sin descripción',
    colorCongelador: '#e2d9d9', //gris
    iconoCongelador: 'images/otros.png'
  }
});

var ProductoModel = Parse.Object.extend({
    className: "Producto",

    initialize:function(){
        console.log("Modelo de productos");
    },
  
  defaults : {
    nombreProducto: 'No especificado',
    descripcionProducto: 'Sin descripción'
  }
});

var CategoriaModel = Parse.Object.extend({
    className: "Categoria",

    initialize:function(){
        console.log("Modelo de categorias");
    },
  
  defaults : {
    nombreCategoria: 'No especificado',
    descripcionCategoria: 'Sin descripción',
    iconoCategoria: 'images/otros.png'

  }
});

var CongeladorCollection = Parse.Collection.extend({
    model: CongeladorModel,

    localStorage: new Store("congeladores"),
});

var ProductoCollection = Parse.Collection.extend({
    model: ProductoModel,

    localStorage: new Store("productos"),
});

var CategoriaCollection = Parse.Collection.extend({
    model: CategoriaModel,

    localStorage: new Store("categorias"),
});

$(document).ready(function () {
    console.log('document ready');
    Parse.initialize("Xh6Xr256KaPzmlDhXGiModlvdr7XyrVBvEkWXGkH","WPKuZJOcbzTlSMdjIaHTXLcoTXJYoGkMkF2a8mud"); 
    app = new AppRouter();
    Backbone.history.start();
});